/*
**	$Id: IOChannel.hpp 1.3 1995/10/13 11:43:06 olsen Exp olsen $
**
**	:ts=4
*/

/*
 * Copyright  1995 by Olaf Barthel, All Rights Reserved
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO
 * EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * This software has not been validated by the ``Bundesamt fuer Zulassungen in
 * der Telekommunikation'' of the ``Deutsche Bundepost Telekom'' and thus
 * must not be used for accessing the BTX-Network of the Telekom in Germany.
 *
 * Diese Software hat keine Zulassung durch das Bundesamt fuer Zulassungen in
 * der Telekommunikation der Deutschen Bundespost Telekom und darf daher nicht
 * am Netz der Deutschen Bundespost Telekom in Deutschland betrieben werden.
 */

#ifndef _IOCHANNEL_HPP
#define _IOCHANNEL_HPP 1

/****************************************************************************/

#ifndef _TYPES_HPP
#include "Types.hpp"
#endif

/****************************************************************************/

enum
{
	CHANNELERR_Timeout	= -903,
	CHANNELERR_EOF		= -902,
	CHANNELERR_Nothing	= -901
};

class IOChannel
{
	public:

		IOChannel() {};
		virtual ~IOChannel() {};

		virtual LONG Open(CONST STRPTR Channel,ULONG Unit=0,ULONG Baud=0,BOOL RTS_CTS=-1) { return(-1); };
		virtual VOID Close(VOID) {};

		virtual LONG GetChar(LONG Timeout=0) { return(CHANNELERR_EOF); };
		virtual VOID PutChar(UBYTE Char) {};
		virtual VOID PutString(CONST STRPTR String,LONG Len) {};

		virtual LONG GetCharDirect(LONG Timeout=0) { return(CHANNELERR_EOF); };
		virtual VOID PutCharDirect(UBYTE Char) {};
		virtual VOID PutStringDirect(CONST STRPTR String,LONG Len) {};

		virtual VOID Flush(VOID) {};

		virtual LONG Waiting(VOID) { return(0); };

		virtual ULONG WaitMask(VOID) { return(0); };
};

#endif	// _IOCHANNEL_HPP
